;Colour Test Program by Chris Covell
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

   ORG   $C000    ;16Kb PRG-ROM, 8Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$06    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0



;********* Initialize Name Table to specified pattern ******

   ldx   #$20
   stx   $2006
   ldx   #$00
   stx   $2006

   lda   #$24        ;Blank Pattern
   ldy   #$F0        ;240 times...
.OuterLoop sta $2007
   sta   $2007
   sta   $2007
   sta   $2007
   dey
   bne .OuterLoop

;***********************************************************

;********* Set Name Table *********************

   ldx   #$20     ;Point to Name Table 0
   stx   $2006
   ldx   #$20
   stx   $2006

;--------------- " COLOUR TEST PROGRAM" -----
   ldx   #$24
   stx   $2007
   ldx   #$C
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$1E
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$1D
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$19
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$10
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$A
   stx   $2007
   ldx   #$16
   stx   $2007
;-------------------

;------------------- " BY CHRIS C."
   ldx   #$24
   stx   $2007
   ldx   #$B
   stx   $2007
   ldx   #$22
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$C
   stx   $2007
   ldx   #$11
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$12
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$C
   stx   $2007
   ldx   #$2C
   stx   $2007
;-------------------



   ldx   #$32     ;Gradient Character
   ldy   #$20     ;One Line
.RedStripe1 stx   $2007
   dey
   bne   .RedStripe1

   ldx   #$33     ;Gradient Character
   ldy   #$20     ;One Line
.RedStripe2 stx   $2007
   dey
   bne   .RedStripe2

   ldx   #$32     ;Gradient Character
   ldy   #$20     ;One Line
.GreenStripe1 stx   $2007
   dey
   bne   .GreenStripe1

   ldx   #$33     ;Gradient Character
   ldy   #$20     ;One Line
.GreenStripe2 stx   $2007
   dey
   bne   .GreenStripe2

   ldx   #$32     ;Gradient Character
   ldy   #$20     ;One Line
.BlueStripe1 stx   $2007
   dey
   bne   .BlueStripe1

   ldx   #$33     ;Gradient Character
   ldy   #$20     ;One Line
.BlueStripe2 stx   $2007
   dey
   bne   .BlueStripe2

;------------------- "PRESS L,R FOR HUE, U,D FOR VALUE" -------

   ldx   #$19
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$1C
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$28
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$F
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$11
   stx   $2007
   ldx   #$1E
   stx   $2007
   ldx   #$E
   stx   $2007
   ldx   #$28
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$1E
   stx   $2007
   ldx   #$28
   stx   $2007
   ldx   #$D
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$F
   stx   $2007
   ldx   #$18
   stx   $2007
   ldx   #$1B
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$1F
   stx   $2007
   ldx   #$A
   stx   $2007
   ldx   #$15
   stx   $2007
   ldx   #$1E
   stx   $2007
   ldx   #$E
   stx   $2007
;------------------------------------

   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldy   #$1C
   ldx   #$26
.CycleBar   stx   $2007
   dey
   bne   .CycleBar
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldy   #$1C
   ldx   #$26
.CycleBar2   stx   $2007
   dey
   bne   .CycleBar2
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldy   #$1C
   ldx   #$26
.CycleBar3   stx   $2007
   dey
   bne   .CycleBar3


   ldx   #$21
   stx   $2006
   ldx   #$A3
   stx   $2006
   ldx   #$34
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$35
   stx   $2007

   ldy   #$5
   ldx   #$24
.Spc1   stx   $2007
   dey
   bne   .Spc1

   ldx   #$34
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$35
   stx   $2007

   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007

   ldx   #$34
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$35
   stx   $2007

   ldy   #$7
   ldx   #$24
.Spc2   stx   $2007
   dey
   bne   .Spc2

   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$34
   stx   $2007
   ldx   #$35
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$34
   stx   $2007
   ldx   #$3B
   stx   $2007

   ldy   #$7
   ldx   #$24
.Spc3   stx   $2007
   dey
   bne   .Spc3

   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$34
   stx   $2007
   ldx   #$35
   stx   $2007

   ldy   #$6
   ldx   #$24
.Spc4   stx   $2007
   dey
   bne   .Spc4

   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$34
   stx   $2007
   ldx   #$3B
   stx   $2007

   ldy   #$8
   ldx   #$24
.Spc5   stx   $2007
   dey
   bne   .Spc5

   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007

   ldy   #$6
   ldx   #$24
.Spc6   stx   $2007
   dey
   bne   .Spc6

   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$34
   stx   $2007
   ldx   #$3B
   stx   $2007
   ldx   #$37
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$34
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$35
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007

   ldx   #$30
   stx   $2007
   ldx   #$3A
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$3B
   stx   $2007

   ldy   #$7
   ldx   #$24
.Spc7   stx   $2007
   dey
   bne   .Spc7

   ldx   #$30
   stx   $2007
   ldx   #$3A
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$32
   stx   $2007
   ldx   #$3B
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$36
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$35
   stx   $2007

   ldy   #$6
   ldx   #$24
.Spc8   stx   $2007
   dey
   bne   .Spc8

   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$27
   stx   $2007
   ldx   #$35
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$3A
   stx   $2007
   ldx   #$35
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$31
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$30
   stx   $2007
   ldx   #$37
   stx   $2007

   ldy   #$6
   ldx   #$24
.Spc9   stx   $2007
   dey
   bne   .Spc9

   ldx   #$36
   stx   $2007
   ldx   #$37
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$36
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$37
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007

   ldx   #$36
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$37
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$24
   stx   $2007
   ldx   #$36
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$33
   stx   $2007
   ldx   #$37
   stx   $2007
   ldx   #$24
   stx   $2007
   stx   $2007


   ldx   #$22
   stx   $2006
   ldx   #$C3
   stx   $2006
   ldx   #%10000100
   stx   $2000
   ldx   #$25
   ldy   #$8
.Bar1 stx   $2007
   dey
   bne .Bar1

   ldx   #$22
   stx   $2006
   ldx   #$C4
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar2 stx   $2007
   dey
   bne .Bar2

   ldx   #$22
   stx   $2006
   ldx   #$C5
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar3 stx   $2007
   dey
   bne .Bar3

   ldx   #$22
   stx   $2006
   ldx   #$C6
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar4 stx   $2007
   dey
   bne .Bar4

   ldx   #$22
   stx   $2006
   ldx   #$C7
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar5 stx   $2007
   dey
   bne .Bar5

   ldx   #$22
   stx   $2006
   ldx   #$C8
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar6 stx   $2007
   dey
   bne .Bar6

   ldx   #$22
   stx   $2006
   ldx   #$C9
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar7 stx   $2007
   dey
   bne .Bar7

   ldx   #$22
   stx   $2006
   ldx   #$CB
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar8 stx   $2007
   dey
   bne .Bar8

   ldx   #$22
   stx   $2006
   ldx   #$CC
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar9 stx   $2007
   dey
   bne .Bar9

   ldx   #$22
   stx   $2006
   ldx   #$CD
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar10 stx   $2007
   dey
   bne .Bar10

   ldx   #$22
   stx   $2006
   ldx   #$CE
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar11 stx   $2007
   dey
   bne .Bar11

   ldx   #$22
   stx   $2006
   ldx   #$CF
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar12 stx   $2007
   dey
   bne .Bar12

   ldx   #$22
   stx   $2006
   ldx   #$D0
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar13 stx   $2007
   dey
   bne .Bar13

   ldx   #$22
   stx   $2006
   ldx   #$D1
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar14 stx   $2007
   dey
   bne .Bar14

   ldx   #$22
   stx   $2006
   ldx   #$D2
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar15 stx   $2007
   dey
   bne .Bar15

   ldx   #$22
   stx   $2006
   ldx   #$D3
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar16 stx   $2007
   dey
   bne .Bar16

   ldx   #$22
   stx   $2006
   ldx   #$D4
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar17 stx   $2007
   dey
   bne .Bar17

   ldx   #$22
   stx   $2006
   ldx   #$D6
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar18 stx   $2007
   dey
   bne .Bar18

   ldx   #$22
   stx   $2006
   ldx   #$D7
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar19 stx   $2007
   dey
   bne .Bar19

   ldx   #$22
   stx   $2006
   ldx   #$D8
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar20 stx   $2007
   dey
   bne .Bar20

   ldx   #$22
   stx   $2006
   ldx   #$D9
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar21 stx   $2007
   dey
   bne .Bar21

   ldx   #$22
   stx   $2006
   ldx   #$DA
   stx   $2006
   ldx   #$27
   ldy   #$8
.Bar22 stx   $2007
   dey
   bne .Bar22

   ldx   #$22
   stx   $2006
   ldx   #$DB
   stx   $2006
   ldx   #$26
   ldy   #$8
.Bar23 stx   $2007
   dey
   bne .Bar23

   ldx   #$22
   stx   $2006
   ldx   #$DC
   stx   $2006
   ldx   #$25
   ldy   #$8
.Bar24 stx   $2007
   dey
   bne .Bar24


   ldx   #%10000000
   stx   $2000

   ldx   #$24
   stx   $2007
   stx   $2007


;***********************************************


;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$0D     ;Colour Value
   ldy   #$20
.InitPal stx $2007
   dey
   bne   .InitPal

;*********************************************************

;********* Set Palette *************************

   ldx   #$3F
   stx   $2006
   ldx   #$01
   stx   $2006

   ldx   #$20
   stx   $2007
   ldx   #$00
   stx   $2007
   ldx   #$00
   stx   $2007

   ldx   #$D
   stx   $2007
   ldx   #$06
   stx   $2007
   ldx   #$16
   stx   $2007
   ldx   #$26
   stx   $2007

   ldx   #$D
   stx   $2007
   ldx   #$0A
   stx   $2007
   ldx   #$1A
   stx   $2007
   ldx   #$2A
   stx   $2007

   ldx   #$D
   stx   $2007
   ldx   #$02
   stx   $2007
   ldx   #$12
   stx   $2007
   ldx   #$22
   stx   $2007

;***********************************************


;*********** Initialize Attribute Table ******************

   ldx   #$23
   stx   $2006
   ldx   #$C0
   stx   $2006

   ldy   #$8
   ldx   #%01010000
.Attr1   stx   $2007
   dey
   bne   .Attr1

   ldy   #$8
   ldx   #%11111010
.Attr2   stx   $2007
   dey
   bne   .Attr2

   ldx   #$23
   stx   $2006
   ldx   #$D8
   stx   $2006

   ldy   #$5
.3Bars
   ldx   #%01010101
   stx   $2007
   stx   $2007
   ldx   #%10011001
   stx   $2007
   ldx   #%10101010
   stx   $2007
   stx   $2007
   ldx   #%11101110
   stx   $2007
   ldx   #%11111111
   stx   $2007
   stx   $2007
   dey
   bne   .3Bars

;Enable vblank interrupts, etc.
   lda   #$80
   sta   $2000
   lda   #$E        ;Screen on, sprites off, show leftmost 8 pixels, colour
   sta   $2001
;  cli            ;Enable interrupts(?)

;Now just loop forever?
.Loop jmp   .Loop




NMI_Routine SUBROUTINE

;First, save the registers
   php
   pha
   txa
   pha
   tya
   pha

   ldx   $00      ;Get previous button status byte
   stx   $01      ;Put it in $01

;Controller read routine, by Kevin Horton.

   LDY   #$08     ;Number of iterations
   LDX   #$01
   STX   $4016    ;store 1 out the strobe
   DEX
   STX   $4016    ;store 0 out the strobe
.ReadBit
   LDA   $4016    ;read the button
   ROR         ;transfer it to the carry flag
   TXA
   ROL
   TAX         ;rotate X left, storing the bit into the lowest pos.
   DEY
   BNE   .ReadBit ;loop 8 times for all 8 buttons
;  RTS         ;return acc with status of all 8 buttons

   and   #$0F     ;Only interested in U & D at the moment
   sta   $00      ;Use location 0 for storing current controller button data

;Next inst unnecessary since last inst was sta $00
;  lda   $00      ;Get current button status
   beq   .DoNothing  ;If neither button pressed

   lda   $01      ;Get previous button status
   eor   #$FF     ;NOT it
   and   $00      ;AND this with current status
   beq   .DoNothing  ;If no change from last time, do nothing

;Now we can see what action to take.
;If U pressed, shift bars one to the right (i.e., increment palette settings).
;If D pressed, shift bars one to the left (i.e., decrement palette settintgs).

   ldx   #$3F
   stx   $2006
   ldx   #$02
   stx   $2006
   ldy   $2007 ;read palette index 2.

   rol         ;So UP status in carry
   rol
   rol
   rol
   rol
   bcc   .NotU

;Shift palette "up by 16"
   pha
   tya
   clc
   adc   #$10
   tay
   pla

.NotU rol         ;So DOWN status in carry
   bcc   .NotD

;Shift palette "down by 16"
   pha
   tya
   sec
   sbc   #$10
   tay
   pla

.NotD rol         ;So LEFT status in carry
   bcc   .NotL

;Shift palette "down by one"
   dey

.NotL rol         ;So RIGHT status in carry
   bcc   .NotR

;Shift palette "up by one"
   iny

.NotR

   ldx   #$3F
   stx   $2006
   ldx   #$02
   stx   $2006
   sty   $2007 ;write palette index 1.
   sty   $2
   ldx   #$21
   stx   $2006
   ldx   #$41
   stx   $2006
   tya
   ror
   ror
   ror
   ror
   and   #$F
   sta   $2007
   tya
   and   #$F
   tay
   sty   $2007


.DoNothing        ;Restore registers and exit.

   ldx   #$0
   stx   $2005
   stx   $2005

   pla
   tay
   pla
   tax
   pla
   plp
IRQ_Routine       ;Dummy label
   rti




;That's all the code. Now we just need to set the vector table appropriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
